﻿using System;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.SilverlightEdition;
using System.Collections.ObjectModel;

namespace HelloWorld.Web
{
    public class CustomServerLayerOverlay : ServerLayerOverlay
    {
      
        public CustomServerLayerOverlay(string id)
            : base(id)
        { }

        protected void DrawCore(GeoCanvas canvas, object nativeImage, RectangleShape canvasExtent, GeographyUnit mapUnit)
        {
            var labeledFeaturesInLayers = new Collection<SimpleCandidate>();
            foreach (var layer in Layers)
            {
                canvas.BeginDrawing(nativeImage, canvasExtent, mapUnit);
                lock (layer)
                {
                    layer.Open();
                    layer.Draw(canvas, labeledFeaturesInLayers);
                }
                canvas.EndDrawing();
            }
        }

    }
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            const string mapCachePath=@"C:\Bhavya\CacheGenerator\post12556\CacheGenerator\MapCache";
            if (!Page.IsPostBack)
            {
                var ecwRasterLayer_1 = new Jpeg2000RasterLayer(@"C:\Users\E471211\Downloads\HelloWorld_Silverlight_CSharp\HelloWorld.Web\App_Data\HTSL_1.jp2");
                //GdiPlusRasterLayer ecwRasterLayer_1 = new GdiPlusRasterLayer(MapPath("~/App_Data/Tile1.JPG"),new RectangleShape(-180,90,180,-90));
                //ecwRasterLayer_1.UpperThreshold = double.MaxValue;
                //ecwRasterLayer_1.LowerThreshold = 0;
                // Native Server 1
                BackgroundLayer backgroundLayer = new BackgroundLayer(new GeoSolidBrush(GeoColor.FromArgb(255, 156, 187, 216)));

                CustomServerLayerOverlay layerOverlay = new CustomServerLayerOverlay("HTSL_1.jp2");
                layerOverlay.Layers.Add(ecwRasterLayer_1);               
                // TODO: To add server caching
                layerOverlay.ServerCache = new ServerCache(mapCachePath);
              //  layerOverlay.ServerCache.CacheId = layerOverlay.Id;
               
                SilverlightMapConnector1.ServerLayerOverlays.Add(layerOverlay);
               
            }
        }
    }
}